#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "fill.h"
#include "avg.h"
#include "echo.h"
#include "allocate2d.h"
#include "free2d.h"
#include "parse_cmd.h"


int main(int argc, char** argv) {
  float** array_a;
  float** array_b;
  int a_length_i, a_length_j;
  int b_length_i, b_length_j;

  parse_cmd(argc, argv, &a_length_i, &a_length_j, &b_length_i, &b_length_j);

  // Allocazione
  if( allocate2d(a_length_i, a_length_j, &array_a) != 0 ) {
    printf("Cannot allocate array_a.\n");
    return 1;
  }

  if( allocate2d(b_length_i, b_length_j, &array_b) != 0 ) {
    printf("Cannot allocate array_b.\n");
    return 1;
  }

  // Stampa array non inizializzati:
  // non molto utile ma divertente
  echo(array_a, a_length_i, a_length_j);
  echo(array_b, b_length_i, b_length_j);

  // Inizializzazione seme per generazione
  // numeri (non proprio) casuali.
  #ifdef DISABLE_RANDOM
  srand(1);
  #else
  srand(time(NULL));
  #endif

  // Riempimento array
  fill(array_a, a_length_i, a_length_j);
  fill(array_b, b_length_i, b_length_j);

  // Stampa array inizializzati
  echo(array_a, a_length_i, a_length_j);
  echo(array_b, b_length_i, b_length_j);

  // Calcolo media
  float avg_a = avg(array_a, a_length_i, a_length_j);
  float avg_b = avg(array_b, b_length_i, b_length_j);

  // Stampa medie
  printf("Media array a = %e\n", avg_a);
  printf("Media array b = %e\n", avg_b);

  // Libera array
  free2d(a_length_i, array_a);
  free2d(b_length_i, array_b);

  return 0;
}
